#ifndef ROW_H
#define ROW_H

#include"note.h"
#include"interval.h"

class Row{
public:
  void setLine(char line[]);
  void divide(char *line);
  void setPlithos(int plithos);
  void setNotes(int num_notes[][2]);
  void setNotes(int position, Note One);
  int getPlithos(void);
  void make(char *line);
  // Check if the row is in TeX or in German mode.
  int check4tex(void);
  // Return the note at "position".
  Note getNotes(int position);

  // MODIFIERS
  // Transpose the row at a specific interval.
  void transpose(Interval Diastima);
  // Turn the row over (retrograde)
  void retrograde(void);
  // Invert the row.
  void invert(void);
  // Change the note at position i in its enharmonic one.
  void enharmonic(int i);
  void smooth(Note Basi);
  void climax(void);
  // FILTERS
  // Disable triple accidentals
  void filter3(void);
  // Disable double accidentals
  void filter2(void);
  // Disable simple accidentals at e/b sharp and c/f flat.
  void filter1(void);
  // Move the row at the treble-clef region.
  void ambitus(void);

  int chr_interval(Note One, Note Two);
  int recognize(Note One, Note Two, Interval& Diastima);
private:
  void set_char_gRow(void);
  void set_char_TeXRow(void);
  void tex2num(void);
  void german2num(void);
  int chromatic_big(int x, int y);
  int chromatic_big(Note One);
  bool input_code(char arxi);
  char itsLine[100];
  char sep_notes[24][7];
  int itsPlithos;
  Note itsNotes[24];
};

#endif
